--[[
	Iteratv s rekurzv rendez s keres
	algoritmusokat megvalst knyvtr.

	A fggvnyek (a bubble_sort kivtelvel) mind
	rendszeresen visszaadjk a 	vezrlst a hvnak,
	hogy tjkoztassk a kszltsgi llapotrl, ezrt
	csak coroutine-knt hvhatk.

	A knyvtrat rdemes lenne kiegszteni gy, hogy a
	fggvnyek nmagukban is hvhatak legyenek.
]]

-- Ltrehozzuk az "array knyvtrat".
array = {}

-- Buborkrendez algoritmus.
array.bubble_sort = function(a, startindex, endindex)
	n = endindex

	-- Egyre rvidebb rszsorozatokban "felbuborkoltatjuk"
	-- a legnagyobb elemet a rszsorozat vgre.
	while(n > startindex) do
		for i = startindex, n-1 do
			-- Ha az aktulis elem nagyobb mint a kvetkez,
			-- megcserljk ket.
			if a[i] > a[i+1] then
				-- A Lua szimultn rtkadsnak egy
				-- trivilis elnye: egysoros csere.
				a[i], a[i+1] = a[i+1], a[i]
			end
		end

		-- Cskkentjk a vizsglt rszsorozat mrett.
		n = n-1
	end
end

--	Rekurzv gyorsrendezs, buborkrendezssel
--	az elg rvid rszsorozatokra.
array.quick_sort = function(a, startindex, endindex)
	-- res sorozatokat nem kell rendezni.
	if startindex >= endindex then
		return
	end

	-- Ilyen rvid rszsorozatokra hatkonyabb a
	-- buborkrendezs.
	if endindex - startindex <= 5 then
		array.bubble_sort(a, startindex, endindex)
		return
	end

	local s = startindex
	local e = endindex
	-- Automatikus kerektsek miatt nem kell aggdnunk,
	-- neknk kell kerekteni, ha szksges.
	local mid = startindex + math.floor((e - s) / 2)
	local pivot = a[mid]

	-- Felcserljk a kzps s az utols elemet.
	a[mid], a[e] = a[e], pivot

	-- A sorozaton vgigmenve keresnk elrl egy, a
	-- pivotnl nagyobb, htulrl egy, a pivotnl kisebb
	-- elemet.
	-- Ha tallunk ilyeneket, megcserljk ket, mg vgl
	-- egy rendezett rszsorozatot kapunk kzpen.
	while s < e do
		while a[s] <= pivot and s < e do
			-- Nincsen += vagy ++.
			s = s + 1
		end
		while pivot <= a[e] and s < e do
			e = e -1
		end
		if s < e then
			a[s], a[e] = a[e], a[s]
		end
	end

	-- A pivot element visszahelyezzk a rszsorozat vgre.
	a[endindex], a[e] = a[e], pivot;

	-- Ugyangy rendezzk a rszsorozat eltti s utni szakaszt.
	array.quick_sort(a, startindex, s-1);
	array.quick_sort(a, e+1, endindex);
	-- Visszaadjuk a vezrlst a coroutine hvjnak,
	-- tjkoztatva a hvt az algoritmus pillanatnyi
	-- llapotrl (0 s 1 kzti kszltsg).
	-- A vezrls visszaadsa gy minden rekurzv hvs vgn,
	-- teht ersen vltoz idkznknt trtnik.
	coroutine.yield(endindex / #a)
end

-- Binris keress egy tmbben adott rtkre, adott kezd s
-- zr index kzt.
array.bin_search = function(a, value, startindex, endindex)
	-- res sorozatban nem tallhatjuk meg, amit keresnk.
	if startindex > endindex then
		return nil
	end

	local mid = startindex + math.floor((endindex - startindex) / 2)

	-- A sorozat kzps elemt vizsgljuk.
	if a[mid] == value then
		return mid
	end

	-- Ha nem talltuk meg a keresett rtket, a baloldali vagy
	-- a jobboldali rszsorozatot vizsgljuk tovbb attl fggen,
	-- hogy kzps rtk nagyobb vagy kisebb volt-e mint a keresett.
	if a[mid] > value then
		s, e = startindex, mid-1
	else
		s, e = mid+1, endindex
	end

	-- Visszaadjuk a vezrlst a coroutine hvjnak,
	-- tjkoztatva a hvt az algoritmus pillanatnyi llapotrl
	-- (0 s 1 kzti kszltsg)
	coroutine.yield((#a - e + s) / #a)
	-- Ez az elgazs biztostja, hogy rekurzis lnc legkls
	-- hvsa visszatrjen az algoritmus elkszltt jelz 1-essel
	-- is.
	if endindex == #a then
		return 1, array.bin_search(a, value, s, e)
	end

	-- A Lua biztostja, hogy ez a rekurzv hvs, mivel a
	-- fggvny utols utastsa, ugyanazt trterletet kapja,
	-- mint a hvja (proper tail call).
	-- gy gyakorlatilag vgtelen rekurzi is lehetsges.
	return array.bin_search(a, value, s, e)
end
