--[[
	Egy input fjlbl beolvassuk egy szmsort, majd
	ezt rendezzk. A rendezett sorozatban megkeressk a
	42-es szm egy elfordulst (ha van), vgl a sorozatot
	egy output fjlba rjuk.
]]

-- Az ugyanebben a knyvtrban lv "array.lua " s
-- "anim.lua" nev fjlt importljuk.
require("array")
require("anim")

-- Beolvassa a megadott fjl tartalmt a kapott tmbbe.
-- A fjl szmok sorozatt kell hogy tartalmazza, amelyek
-- kzl az els az elemek szma.
read_from_file =
	function(f, a)
		local n = f:read("*n")
		local k = 0;

		local num = f:read("*n")
		while num do
			table.insert(a, num)
			k = k + 1
			coroutine.yield(k / n)
			num = f:read("*n")
		end

		return 1
	end

-- Kirja a megadott fjlba a kapott tmbt, az elemek
-- szmval kezdve.
write_to_file =
	function(f, a)
		f:write(#a.."\n")
		for i = 1, #a do
			f:write(a[i].." ")
			coroutine.yield(i / #a)
		end

		return 1
	end

-- Parancssori argumentumok vagy default rtkek.
input_filename = arg[1] or "lua_testdata"
output_filename = arg[2] or input_filename.."_sorted"

a = {}

-- Olvassra nyitjuk meg az input fjlt.
f = io.open(input_filename, "r")

print("Reading input...")
-- Fjlbl olvass progress barral.
anim.exec_animated(0.1, read_from_file, f, a)

f:close()

print("Sorting...")
-- Gyorsrendezs progress barral.
anim.exec_animated(0.1, array.quick_sort, a, 1, #a)

print("Searching for 42 in data...")
-- Binris keress progress barral. Az anim.exec_animated fggvny
-- az array.bin_search els "normlis" visszatrsi rtkvel fog
-- visszatrni (amit itt a tallt elem indexe, ha van).
ind42 = anim.exec_animated(0.1, array.bin_search, a, 42, 1, #a)

if ind42 then
	print("Found 42 in input at position: "..ind42)
else
	print("42 not found in input.")
end

-- Output fjl menyitsa rsra.
f = io.open(output_filename, "w")

print("Writing to file...")
-- Fjlba rs progress barral.
anim.exec_animated(0.1, write_to_file, f, a)

f:close()
